`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// 2017
//////////////////////////////////////////////////////////////////////////////////

module VGA_IMG ();

localparam HDISP = 640;
localparam VDISP = 480;

localparam HLIM = 800;
localparam VLIM = 525;

localparam TOTAL = HLIM*VLIM;

integer f;

reg clk25, rst;

wire vid_on, hSync, vSync;
wire [3:0] red, green, blue;
wire [10:0] row, col;

VGASync i_vga_sync (
    .clk25(clk25), .rst(rst),
    .hsync(hSync), .vsync(vSync), .vid_on(vid_on),
    .row(row), .col(col));

VGAColourBars i_vga_colour_bars (
    .clk(clk25), .rst(rst), 
    .row(row), .col(col),
    .red(red), .green(green), .blue(blue));

initial
begin
    f = $fopen("image.pbm", "w");
    $fwrite(f, "P3\n%d %d\n15\n", HDISP, VDISP);
    rst = 1;
    clk25 = 0;

    @(posedge clk25);
    @(posedge clk25);
    rst = 0;

    @(negedge vSync);
    $fclose(f);
    $stop;
end

always
    #20 clk25 = !clk25;

always@ (posedge clk25)
begin
    if (vid_on) begin
	$fwrite(f, "%d %d %d\n", red, green, blue);
    end
end

endmodule
